const http = require('http');
const debug = require('debug')('client');
const JSONfn = require('json-fn')

var sendScriptJob = function( scriptObj , callback ){
  var timeA =  Date.now()
  var heapStart = process.memoryUsage().rss


////// POST ////////////

  var postData = JSONfn.stringify( scriptObj );

  var options = {
    hostname: 'localhost',
    port: 8000,
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    reconnect: true
  };

  var keepAliveAgent = new http.Agent({ keepAlive: true });
  options.agent = keepAliveAgent;

  var request = http.request( options, function( response ){
    debug('request - response statusCode ', response.statusCode);

    var body = '';

    response.on('data', function(chunk) {
      // debug('chunk', chunk.toString() );
        body += chunk;
    });

    response.on('end', function() {
      // debug('body', body);
      // debug('http-client.js - body: ', body);
      body = JSON.parse( body )
      if ( response.statusCode === 200 ){
        callback( null, body )
      }else{
        callback( body, null )
      }

      debug('!!! http-client.js - SANDBOX RESPONSE TIME  !!! ', Date.now() - timeA );

      debug( "http-client.js - client process memoryUsage increase " + (process.memoryUsage().rss - heapStart)/1000000 )


    });

    response.on('error', function(err) {
      debug('http-client.js - request - response error ', err);
      //TODO: No response to user?
    });
  });

  //timeout on loops requires error event after data event
  request.on('error', function(e) {

    //socket hangup reported here - socket hang up
    debug('http-client.js - request - Got error:', e );
    callback( { message: e.message, statusCode: 500 } , null )

  });

  // write data to request body
  request.write(postData);
  request.end();

}

module.exports = sendScriptJob
