const http = require('http');
const sandbox = require('./sandbox.js')
const debug = require('debug')('worker');
const JSONfn = require('json-fn')


var heapStart = process.memoryUsage().rss

var server = http.createServer(function(req, response ) {
  //send the process id for timeout function
  debug(`Worker ${process.pid} is running`);

  process.send(process.pid)

  var body = '';
  req.on('data', function (data) {
    // debug('http-worker.js - request buffer received ', data)
    body += data;
  });

  req.on('end', function () {
    var scriptObj = JSONfn.parse( body )
    // debug( 'request -  scriptObj:', scriptObj )

      sandbox( scriptObj.script , scriptObj.libs , scriptObj.context, function(err, res ){
        if( err ){
          debug("sandbox err:", err)
          response.writeHead( 500, { 'Content-Type': 'application/json'});

        }else{
          debug("sandbox res:", res)

          // ask master to clear the master timeout, so the process doesn't end
          process.send( "clearTimeout");
          response.writeHead( 200, { 'Content-Type': 'application/json'});

        }

        var output = res || err
        response.write( JSON.stringify( output ) ); // errors were not being reported
        response.end()
        // process.send( "http-worker.js - process memoryUsage increase " + (process.memoryUsage().rss - heapStart)/1000000 )
      });



  });
});


server.listen(8000);
//
server.on('clientError', (err, socket) => {
  debug('http-worker.js - clientError - bad request', err);
  // socket.end('HTTP/1.1 400 Bad Request\r\n\r\n');
});

server.on('error', (err, socket) => {
  process.send('http-worker.js -  error - unknown ' +  err);
  // socket.end('HTTP/1.1 400 Bad Request\r\n\r\n');
});

process.on('uncaughtException', function(err) {
  process.send("http-worker.js - uncaughtException " + err.stack);
  // console.error(err.stack);
  process.exit();
});

server.on('listening', function(){
  // debug('http-worker.js - server listening ')
  process.send( 'ready' );
});
